/*
 * Scrobble.java
 * 
 * Copyright (c) David Pollack 2009-2010
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

package ScrobbleBerry;

import java.io.*;

class Scrobble {
    private String _artist;
    private String _track;
    private String _album;
    private String _length;
    private String _tracknumber;
    private long _timestamp;
    
    Scrobble(String artist, String track, String album,
                String length, String tracknumber, long timestamp) {
        _artist = artist;
        _track = track;
        _album = album;
        _length = length;
        _tracknumber = tracknumber;
        _timestamp = timestamp;
    }
    Scrobble(byte[] scrobble) {
        try {
            fromByteArray(scrobble);
        } catch (IOException e) {
        }
    }
    
    String getArtist() {
        return _artist;
    }
    String getTrack() {
        return _track;
    }
    String getAlbum() {
        return _album;
    }
    String getLength() {
        return _length;
    }
    String getTrackNumber() {
        return _tracknumber;
    }
    long getTimestamp() {
        return _timestamp;
    }
    
    public void fromByteArray(byte[] scrobble) throws IOException {
        ByteArrayInputStream bin = new ByteArrayInputStream(scrobble);
        DataInputStream din = new DataInputStream(bin);
        
        _artist = din.readUTF();
        _track = din.readUTF();
        _album = din.readUTF();
        _length = din.readUTF();
        _tracknumber = din.readUTF();
        _timestamp = din.readLong();
        
        din.close();
    }
    
    public byte[] toByteArray() throws IOException {
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream(bout);
        
        dout.writeUTF(getArtist());
        dout.writeUTF(getTrack());
        dout.writeUTF(getAlbum());
        dout.writeUTF(getLength());
        dout.writeUTF(getTrackNumber());
        dout.writeLong(getTimestamp());
        
        dout.close();
        
        return bout.toByteArray();
    }
}
